#!/usr/bin/python3

import rospy
import numpy as np
from geometry_msgs.msg import PoseStamped
from geometry_msgs.msg import Transform

transform = Transform()
def callback(data):
    # save the pose date in transform
    transform.rotation = data.pose.orientation
    # we must remapp
    #transform.translation = data.pose.position
    transform.translation.x = data.pose.position.x
    transform.translation.y = data.pose.position.z
    transform.translation.z = data.pose.position.y

def main():
    global transform
    rospy.init_node("qualisysFeedback", anonymous = True)
    name = rospy.get_param("~trackName")
    namespace = rospy.get_param("~qualisysName")
    rospy.loginfo("looking for track of name " + str(name) + " ...")
    rospy.Subscriber("/" + namespace + "/qualisys/" + name + "/pose", PoseStamped, callback, queue_size = 1)
    pub = rospy.Publisher(namespace + "/pose_feedback", Transform, queue_size = 1)
    while not rospy.is_shutdown():
        pub.publish(transform)

if __name__ == '__main__':
    main()
