#!/usr/bin/python3
from tools import meters2lat_lon, lat_lon2meters
import numpy as np
import rospy

def normalizeAngle(angle):
    newAngle = angle%360
    newAngle = (newAngle + 360)%360
    if(newAngle >= 180):
        newAngle -= 360
    return newAngle

def generateWaypoints():
    rospy.init_node("waypointGenerator")
    anchorPoint = rospy.get_param("~anchorPoint")
    baseWaypointAltitude = rospy.get_param("~altitude")
    droneNum = rospy.get_param("~droneNum")

    waypointAltitudeIncrement = baseWaypointAltitude # increase altitude for each drone in team

    # musical drones trajectory is convient test case, but general path is possible
    # ring sizes
    big = 5
    med = 3
    sml = 1

    apMeters = lat_lon2meters(anchorPoint)

    waypointOffsets = [
    [-big, -big],
    [big, -big],
    [big, big],
    [med, med],
    [-med, med],
    [-med, -med],
    [-sml, -sml],
    [sml, -sml],
    [sml, sml],
    [big, -big],
    ]
    tempDict = {"waypoints" : {}, "positions" : {}, "numWaypoints" : 0, "numPositions" : 0}
    waypointDict = {}
    # define dictionary
    # for temp in range(droneNum):
    #     waypointDict["robot_{}".format(temp)] = tempDict
    numWaypoints = len(waypointOffsets)
    numPositions = len(waypointOffsets) # TODO, add position list to parameters

    # print(waypointDict)

    for d in range(droneNum):
        # rospy.loginfo("blah!")
        # print(d)
        waypointDict["robot_{}".format(d)] = {}
        waypointDict["robot_{}".format(d)] = {}
        waypointDict["robot_{}".format(d)]["waypoints"] = {}
        waypointDict["robot_{}".format(d)]["positions"] = {}
        for i, offset in enumerate(waypointOffsets):
            waypointLatLon = meters2lat_lon([apMeters[0] + offset[0], apMeters[1] + offset[1]])
            waypointLatLonRev = meters2lat_lon([apMeters[0] - offset[0], apMeters[1] - offset[1]])
            waypointHeading = (45.0*i)%360.0

            # waypoints
            waypointDict["robot_{}".format(d)]["waypoints"].update({"waypoint_{}".format(i) : [i, waypointLatLon[0], waypointLatLon[1], baseWaypointAltitude + d*waypointAltitudeIncrement, waypointHeading]})
            # positions
            waypointDict["robot_{}".format(d)]["positions"].update({"position_{}".format(i) : [i, offset[0], offset[1], baseWaypointAltitude + d*waypointAltitudeIncrement, waypointHeading]})

        # do this betta
        waypointDict["robot_{}".format(d)]["numWaypoints"] = numWaypoints
        waypointDict["robot_{}".format(d)]["numPositions"] = numPositions
    # print(waypointDict)
    rospy.set_param("/robot_list", waypointDict)
    # print(waypointDict)

if __name__ == "__main__":
    generateWaypoints()
